#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <winsock.h>

#include "..\ICSDecl.h"

main ()

    {
    int     i, result;
    char    c, buf[4096];


    // GPIB init sequence
    SendIFC (0);
    ibsre (0, 1);

    // Send an *IDN? query string to device-4
    Send (0, 4, "*IDN?", 5, NLend);

    if (ibsta & ERR)
        {
        printf ("Error following the *IDN? send\n");
        return (1);
        }

    // Unlisten all, untalk all, 0 listen, 4 talk
    SendCmds (0, "?_ D", 4);

    if (ibsta & ERR)
        {
        printf ("Error after the SendCmds\n");
        return (1);
        }

    // Pre-fill the buffer with NULL's so it becomes a legal C string
    // after reading the data.
    memset (buf, '\0', sizeof(buf));

    // Read the *IDN? query response
    for (i= 0; !(ibsta & ERR) && !(ibsta & END); )
        {
        RcvRespMsg (0, &c, 1, STOPend);

        if (ibsta & ERR)
            {
            printf ("Error received during RcvRespMsg sequence\n");
            printf ("  ibsta = 0x%04X\n", ibsta);
            printf ("  iberr = %d\n", iberr);

            break;
            }

        if (isprint (c))
            buf[i++] = c;
        }

    result = ibsta;

    printf ("Final result after the read:\n");
    printf ("  string: \"%s\"\n", buf);
    printf ("  count = %d bytes\n", strlen(buf));
    printf ("  ibsta = 0x%04X\n", result);

    return (0);
    }

